mod loader;
mod state;

#[cfg (test)]
mod tests;

fn main() {
	use state::State;
	
	let lua_file = {
		let data = std::fs::read ("test_vectors/closure.luac").unwrap ();
		let mut rdr = std::io::Cursor::new (data);
		loader::parse_chunk (&mut rdr).unwrap ()
	};
	
	let mut vm = State::default ();
	if std::env::var("LUA_DEBUG").is_ok() {
		vm.debug_print = true;
	}
	
	let upvalues = State::upvalues_from_args (std::env::args ());
	println! ("Returned: {:?}", vm.execute_chunk (&lua_file, &upvalues));
}
